//app.js on express-sovelluksen päätiedosto
//jossa konfiguroidaan koko sovellus

//ladataan express ja muutamia apumoduuleita
const express = require('express');
const path = require('path'); //tiedostopolun luomiseen
// const favicon = require('serve-favicon');//faviconin tuottamiseen
const logger = require('morgan'); //lokin tuottamiseen konsoliin
const cookieParser = require('cookie-parser'); //cookieiden jäsentämiseen
const bodyParser = require('body-parser'); //http-viestin bodyn jäsentämiseen
const cors = require('cors'); // mahdollistaa yhteyden ulkopuolisiin palvelimiin

//Reittitiedostojen määritys
const index = require('./routes/index');
const users = require('./routes/users');
const ilmot = require('./routes/ilmot');

const app = express(); //Express-sovellusolio syntyy muuttujaan app

app.use(cors()); //cors käyttöönotto

// view engine setup
app.set('views', path.join(__dirname, 'views'));
app.set('view engine', 'ejs');

//middlewaren eli "apumoduulien" käyttöönotto
// uncomment after placing your favicon in /public
//app.use(favicon(path.join(__dirname, 'public', 'favicon.ico')));
app.use(logger('dev'));
app.use(bodyParser.json());
app.use(bodyParser.urlencoded({ extended: false }));
app.use(cookieParser());
app.use(express.static(path.join(__dirname, 'public'))); //kansio josta tarjotaan staattiset filut

//reittien käyttöönotto
app.use('/', index);
app.use('/users', users);
app.use('/ilmot', ilmot);

// catch 404 and forward to error handler
app.use(function (req, res, next) {
  const err = new Error('Not Found');
  err.status = 404;
  next(err);
});

// error handler
app.use(function (err, req, res, next) {
  // set locals, only providing error in development
  res.locals.message = err.message;
  res.locals.error = req.app.get('env') === 'development' ? err : {};

  // render the error page
  res.status(err.status || 500);
  res.render('error');
});

module.exports = app;
